# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'ContainerAppSecretResponse',
    'CustomHostnameAnalysisResultResponseCustomDomainVerificationFailureInfo',
    'CustomHostnameAnalysisResultResponseDetails',
    'DaprSecretResponse',
    'SystemDataResponse',
]

@pulumi.output_type
class ContainerAppSecretResponse(dict):
    """
    Container App Secret.
    """
    def __init__(__self__, *,
                 name: str,
                 value: str):
        """
        Container App Secret.
        :param str name: Secret Name.
        :param str value: Secret Value.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Secret Name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Secret Value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class CustomHostnameAnalysisResultResponseCustomDomainVerificationFailureInfo(dict):
    """
    Raw failure information if DNS verification fails.
    """
    def __init__(__self__, *,
                 code: str,
                 message: str,
                 target: str,
                 details: Optional[Sequence['outputs.CustomHostnameAnalysisResultResponseDetails']] = None):
        """
        Raw failure information if DNS verification fails.
        :param str code: Standardized string to programmatically identify the error.
        :param str message: Detailed error description and debugging information.
        :param str target: Detailed error description and debugging information.
        :param Sequence['CustomHostnameAnalysisResultResponseDetails'] details: Details or the error
        """
        pulumi.set(__self__, "code", code)
        pulumi.set(__self__, "message", message)
        pulumi.set(__self__, "target", target)
        if details is not None:
            pulumi.set(__self__, "details", details)

    @property
    @pulumi.getter
    def code(self) -> str:
        """
        Standardized string to programmatically identify the error.
        """
        return pulumi.get(self, "code")

    @property
    @pulumi.getter
    def message(self) -> str:
        """
        Detailed error description and debugging information.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter
    def target(self) -> str:
        """
        Detailed error description and debugging information.
        """
        return pulumi.get(self, "target")

    @property
    @pulumi.getter
    def details(self) -> Optional[Sequence['outputs.CustomHostnameAnalysisResultResponseDetails']]:
        """
        Details or the error
        """
        return pulumi.get(self, "details")


@pulumi.output_type
class CustomHostnameAnalysisResultResponseDetails(dict):
    """
    Detailed errors.
    """
    def __init__(__self__, *,
                 code: str,
                 message: str,
                 target: str):
        """
        Detailed errors.
        :param str code: Standardized string to programmatically identify the error.
        :param str message: Detailed error description and debugging information.
        :param str target: Detailed error description and debugging information.
        """
        pulumi.set(__self__, "code", code)
        pulumi.set(__self__, "message", message)
        pulumi.set(__self__, "target", target)

    @property
    @pulumi.getter
    def code(self) -> str:
        """
        Standardized string to programmatically identify the error.
        """
        return pulumi.get(self, "code")

    @property
    @pulumi.getter
    def message(self) -> str:
        """
        Detailed error description and debugging information.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter
    def target(self) -> str:
        """
        Detailed error description and debugging information.
        """
        return pulumi.get(self, "target")


@pulumi.output_type
class DaprSecretResponse(dict):
    """
    Dapr component Secret for ListSecrets Action
    """
    def __init__(__self__, *,
                 name: str,
                 value: str):
        """
        Dapr component Secret for ListSecrets Action
        :param str name: Secret Name.
        :param str value: Secret Value.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Secret Name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Secret Value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    def __init__(__self__, *,
                 created_at: Optional[str] = None,
                 created_by: Optional[str] = None,
                 created_by_type: Optional[str] = None,
                 last_modified_at: Optional[str] = None,
                 last_modified_by: Optional[str] = None,
                 last_modified_by_type: Optional[str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param str created_at: The timestamp of resource creation (UTC).
        :param str created_by: The identity that created the resource.
        :param str created_by_type: The type of identity that created the resource.
        :param str last_modified_at: The timestamp of resource last modification (UTC)
        :param str last_modified_by: The identity that last modified the resource.
        :param str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


