# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'DatabaseAccountConnectionStringResponse',
    'PrivilegeResponse',
    'PrivilegeResponseResource',
    'RoleResponse',
]

@pulumi.output_type
class DatabaseAccountConnectionStringResponse(dict):
    """
    Connection string for the Cosmos DB account
    """
    def __init__(__self__, *,
                 connection_string: str,
                 description: str):
        """
        Connection string for the Cosmos DB account
        :param str connection_string: Value of the connection string
        :param str description: Description of the connection string
        """
        pulumi.set(__self__, "connection_string", connection_string)
        pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter(name="connectionString")
    def connection_string(self) -> str:
        """
        Value of the connection string
        """
        return pulumi.get(self, "connection_string")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Description of the connection string
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class PrivilegeResponse(dict):
    """
    The set of data plane operations permitted through this Role Definition.
    """
    def __init__(__self__, *,
                 actions: Optional[Sequence[str]] = None,
                 resource: Optional['outputs.PrivilegeResponseResource'] = None):
        """
        The set of data plane operations permitted through this Role Definition.
        :param Sequence[str] actions: An array of actions that are allowed.
        :param 'PrivilegeResponseResource' resource: An Azure Cosmos DB Mongo DB Resource.
        """
        if actions is not None:
            pulumi.set(__self__, "actions", actions)
        if resource is not None:
            pulumi.set(__self__, "resource", resource)

    @property
    @pulumi.getter
    def actions(self) -> Optional[Sequence[str]]:
        """
        An array of actions that are allowed.
        """
        return pulumi.get(self, "actions")

    @property
    @pulumi.getter
    def resource(self) -> Optional['outputs.PrivilegeResponseResource']:
        """
        An Azure Cosmos DB Mongo DB Resource.
        """
        return pulumi.get(self, "resource")


@pulumi.output_type
class PrivilegeResponseResource(dict):
    """
    An Azure Cosmos DB Mongo DB Resource.
    """
    def __init__(__self__, *,
                 collection: Optional[str] = None,
                 db: Optional[str] = None):
        """
        An Azure Cosmos DB Mongo DB Resource.
        :param str collection: The collection name the role is applied.
        :param str db: The database name the role is applied.
        """
        if collection is not None:
            pulumi.set(__self__, "collection", collection)
        if db is not None:
            pulumi.set(__self__, "db", db)

    @property
    @pulumi.getter
    def collection(self) -> Optional[str]:
        """
        The collection name the role is applied.
        """
        return pulumi.get(self, "collection")

    @property
    @pulumi.getter
    def db(self) -> Optional[str]:
        """
        The database name the role is applied.
        """
        return pulumi.get(self, "db")


@pulumi.output_type
class RoleResponse(dict):
    """
    The set of roles permitted through this Role Definition.
    """
    def __init__(__self__, *,
                 db: Optional[str] = None,
                 role: Optional[str] = None):
        """
        The set of roles permitted through this Role Definition.
        :param str db: The database name the role is applied.
        :param str role: The role name.
        """
        if db is not None:
            pulumi.set(__self__, "db", db)
        if role is not None:
            pulumi.set(__self__, "role", role)

    @property
    @pulumi.getter
    def db(self) -> Optional[str]:
        """
        The database name the role is applied.
        """
        return pulumi.get(self, "db")

    @property
    @pulumi.getter
    def role(self) -> Optional[str]:
        """
        The role name.
        """
        return pulumi.get(self, "role")


